
var oFSO = new ActiveXObject("Scripting.FileSystemObject");
var FOR_READING = 1, FOR_WRITING = 2, FOR_APPENDING = 8;
var TRISTATE_FALSE = 0; // Open the file as ASCII (Default value)
//var TRISTATE_TRUE = -1; // Open the file as Unicode
var TRISTATE_TRUE = 1; // Open the file as Unicode
var TRISTATE_USE_DEFAULT = -2; // Open the file as System Default type


var accounts = getAccounts();
if (!accounts || accounts.length < 1) {
    WScript.Echo("WARNING: Empty account list", false);
    WScript.Quit(1);
}
WScript.Echo("Accounts data:");
printAccauntArray(accounts);

var cripts = new Array(accounts.length);

for (var i = 0; i < accounts.length; i++) {
    cripts[i] = new Array(accounts[i].length);
    for (var j = 0; j < accounts[i].length; j++) {
        cripts[i][j] = getCriptfromStr(accounts[i][j]);
    }
}

var fileCont = "";
for (var i = 0; i < cripts.length; i++) {
    for (var j = 0; j < cripts[i].length; j++) {
        fileCont += cripts[i][j];
    }
}
fileCont = writeFile("acnts.bal", fileCont);
WScript.Echo("");
WScript.Echo("Encrypted account file: " + fileCont);

cripts = getAccountsFromCriptFile();
WScript.Echo("");
WScript.Echo("Check restored accounts data:");
printAccauntArray(cripts);

WScript.Echo("");
if (compareArr(accounts, cripts)) {
    WScript.Echo("The restored data is correct, you can delete the not encrypted account file");
} else {
    WScript.Echo("WARNING: The restored data is incorrect.");
}


function getCriptfromStr(inStr) {
    // get shift X, Y and Z - string len
    var shift1 = 0, shift2 = 0;

    var rez = shiftLetPos(inStr);
    var outStr = rez[0];
    shift1 = rez[1];

//    WScript.Echo("step 1 - " + inStr);
//    WScript.Echo("shift let pos - " + shift1);

    rez = shiftCharCode(outStr);
    outStr = rez[0];
    shift2 = rez[1];

//    WScript.Echo("step 2 - " + inStr);
//    WScript.Echo("shift char code - " + shift2);

    outStr = fillDim(outStr, shift1, shift2);

//    WScript.Echo("step 2 - " + inStr);

    //
    return outStr;
}

function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function shiftLetPos(inStr) {
    var rez = new Array();
    rez[0] = inStr;
    rez[1] = 0;

    var shift = getRandomInt(1, inStr.length - 1);
    
    var outStr = inStr.substr(inStr.length - shift, inStr.length)
            + inStr.substr(0, inStr.length - shift);

    rez[0] = outStr;
    rez[1] = shift;
            
    return rez;
}

function shiftCharCode(inStr) {
    var rez = new Array();
    rez[0] = inStr;
    rez[1] = 0;

    var shift = 255;
    for(var i = 0; i < inStr.length; i++) {
        if (inStr.charCodeAt(i) < shift) shift = inStr.charCodeAt(i);
    }
    shift -= 33;
    if (shift > 0) {
        shift = getRandomInt(1, shift);
        var outStr = "";
        for (var i = 0; i < inStr.length; i++) {
            var code = inStr.charCodeAt(i) - shift;
            outStr += String.fromCharCode(code);
        }
        rez[0] = outStr;
        rez[1] = shift;
    }
    return rez;
}

function fillDim(inStr, shift1, shift2) {
    var val = Math.floor((64 - inStr.length)/2);
    var outStr = ""
    for (var i = 0; i < val; i++) {
        outStr += String.fromCharCode(getRandomInt(33, 126));
    }
    outStr += inStr;
    for (var i = outStr.length; i < 61; i++) {
        outStr += String.fromCharCode(getRandomInt(33, 126));
    }
    outStr += String.fromCharCode(shift1) + String.fromCharCode(shift2) + String.fromCharCode(inStr.length);
    return outStr;
}

function getPasFromStr(inStr) {
//    WScript.Echo("");
    var len_pas = inStr.charCodeAt(inStr.length - 1); // lenth pas str
//    WScript.Echo("lenth pas str - " + len_pas);
    var shift2 = inStr.charCodeAt(inStr.length - 2); // shift char code
//    WScript.Echo("shift char code - " + shift2);
    var shift1 = inStr.charCodeAt(inStr.length - 3); // shift let pos
//    WScript.Echo("shift let pos - " + shift1);
    var val = Math.floor((inStr.length - len_pas)/2);
    var pas_str = inStr.substr(val, len_pas);
//    WScript.Echo("step 2 - " + pas_str);
    // shift char code
    var outStr = "";
    for (var i = 0; i < pas_str.length; i++) {
        var code = pas_str.charCodeAt(i) + shift2;
        outStr += String.fromCharCode(code);
    }
    pas_str = outStr;
//    WScript.Echo("step 1 - " + pas_str);
    // shift let pos
    outStr = pas_str.substr(shift1, pas_str.length)
            + pas_str.substr(0, shift1);
    pas_str = outStr;
//    WScript.Echo("pass - " + pas_str);

    return pas_str;
}

function getAccounts() {
    var oDir = oFSO.GetFolder(".");
    var oEnum = new Enumerator(oDir.Files);
    var arr;
    while (!oEnum.atEnd()) {
        var oFile = oEnum.item();
//        if (oFile.Name.indexOf(scriptName) == -1) {
            var cont = readFile(oFile.Path);
            if (cont.length > 0) {
                var arr1 = cont.split("\r\n");
                arr = new Array(arr1.length);
                for (var i = 0; i < arr1.length; i++) {
                    var arr2 = arr1[i].split("\t");
                    if (arr2.length != 4) {
                        arr = null;
                        break;
                    } else {
                        arr[i] = arr2;
                    }
                }
//            }
            if (arr && arr.length > 0) {
                WScript.Echo("Account file: " + oFile.Path);
                return arr;
            }
        }
        oEnum.moveNext();
    }
    return null;
}

function getAccountsFromCriptFile() {
    var cont = readFile("acnts.bal");
    if (cont.length > 0 && Math.round(cont.length / 64) == cont.length / 64) {
        var val = cont.length / 64 / 4;
        var arr = new Array(val);
        var pos = 0;
        var x = 0, y = 0;
        while (pos + 64 <= cont.length) {
            if (x == 0) arr[y] = new Array(4);
            var val = getPasFromStr(cont.substr(pos, 64));
            arr[y][x] = val;
            pos += 64; x++;
            if (x > 3) {
                y++; x = 0;
            }
        }
        if (arr && arr.length > 0) {
            return arr;
        }
    }
    return null;
}

function readFile(sFile) {
    if (oFSO.FileExists(sFile)) {
        var oTF = oFSO.OpenTextFile(sFile, FOR_READING);
        var sCont = oTF.ReadAll();
        oTF.Close();
        return sCont;
    } else {
        printMes("ERROR: file is not found - '" + sFile + "'");
    }
    return "";
}

function writeFile(sFile, sCont) {
    if (!sCont) sCont = "";
//    var oTF = oFSO.CreateTextFile(sFile, true, true);
    var oTF = oFSO.CreateTextFile(sFile, true);
    oTF.Write(sCont);
    oTF.Close();
    return oFSO.GetAbsolutePathName(sFile);
}

function printAccauntArray(arr) {
    for (var i = 0; i < arr.length; i++) {
        var val = "";
        for (var j = 0; j < arr[i].length; j++) {
            if (val.length > 0) val += "\t";
            val += arr[i][j];
        }
        WScript.Echo(val);
    }
}

function compareArr(arr1, arr2) {
    if (arr1.length == arr2.length) {
        var equal = true;
        for (var y = 0; y < arr1.length; y++) {
            if (arr1[y].length != arr2[y].length) break;
            for (var x = 0; x < arr1[y].length; x++) {
                if (arr1[y][x] != arr2[y][x]) {
                    equal = false;
                    break;
                }
            }
            if (!equal) break;
        }
        return equal;
    }
    return false;
}

// encript.js vers: 1.0.0 (21:47 5.7.2011)	 Voronkov Nikolay	jsbalancer@yandex.ru